package HomeWork.controller;

import HomeWork.common.core.domain.R;
import HomeWork.domain.*;
import HomeWork.service.PeopleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/people")
public class PeopleController {
    @Autowired
    private PeopleService peopleService;

    /**
     * 人员库
     * @return
     */
    @GetMapping("/list")
    public R<List<People>> people() {
        List<People> people = peopleService.list();
        return R.ok(people);
    }

    /**
     * 添加人员库
     * @param people
     * @return
     */
    @PostMapping("/add")
    public R add(@RequestBody People people) {
        peopleService.add(people);
        return R.ok();
    }

    /**
     * 删除人员库
     * @param id
     * @return
     */
    @DeleteMapping("/delete/{id}")
    public R delete(@PathVariable Integer id) {
        R r = peopleService.delete(id);
        return R.ok();
    }

    /**
     * 修改人员库
     * @param people
     * @return
     */

    @PutMapping("/upd")
    public R upd(@RequestBody People people) {
        peopleService.upd(people);
        return R.ok();
    }

    /**
     * 通过人员id查询库里面的人员信息
     * @param id
     * @return
     */

    @GetMapping("/one/{id}")
    public R<PeopleOne> oneList(@PathVariable Integer id) {
        PeopleOne people = peopleService.one(id);
        return R.ok(people);
    }

    /**
     * 通过人员库的人员数获取所有人员库的图片
     * @param id
     * @return
     */

    @GetMapping("/img/{id}")
    public R<List<ImgsEntity>> img(@PathVariable Integer id) {
        List<ImgsEntity> people = peopleService.imgList(id);
        return R.ok(people);
    }

    /**
     * 通过图片id回显数据
     * @param id
     * @return
     */

    @GetMapping("/personage/{id}")
    public R<Personage> personage(@PathVariable Integer id) {
        Personage people = peopleService.PersonageById(id);
        return R.ok(people);
    }

    /**
     * 修改人员数据
     * @param personage
     * @return
     */
    @PutMapping("/updPersonage")
    public R updPersonage(@RequestBody Personage personage) {
        peopleService.updPersonage(personage);
        return R.ok();
    }

    /**
     * 民族下拉框
     * @return
     */

    @GetMapping("/nationList")
    public R<List<Nation>> nationList() {
        List<Nation> people = peopleService.nationList();
        return R.ok(people);
    }

    /**
     * 身份证下拉框
     * @return
     */

    @GetMapping("/IdentityDocumentList")
    public R<List<IdentityDocument>> IdentityDocumentList() {
        List<IdentityDocument> people = peopleService.IdentityDocumentList();
        return R.ok(people);
    }


}
