package HomeWork.controller;

import HomeWork.common.core.domain.R;
import HomeWork.domain.dto.PlotDto;
import HomeWork.domain.vo.PlotVo;
import HomeWork.domain.vo.TreeVo;
import HomeWork.domain.vo.UnitVo;
import HomeWork.service.TreeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@RestController
public class TreeController {

    @Autowired
    private TreeService treeService;

    @GetMapping("/tree")
    public R<List<TreeVo>> tree() {
        List<TreeVo> treeVos= treeService.treeList();
        return R.ok(treeVos);
    }

    @PostMapping("/treeByParentId")
    public R<List<TreeVo>> treeByParentId(@RequestParam("parentId") Integer parentId) {
        List<TreeVo> treeVos= treeService.treeListByTreeParentId(parentId);
        return R.ok(treeVos);
    }

    @PostMapping("/plot/{id}")
    public R<List<PlotVo>> plot(@PathVariable Integer id) {
        List<PlotVo> plotVos= treeService.plotList(id);
        return R.ok(plotVos);
    }

    @PostMapping("/add")
    public R add(@RequestBody PlotDto plotDto) {
        return R.ok(treeService.add(plotDto));
    }

    @PostMapping("/file")
    public R file(@RequestParam("file") MultipartFile file) {
        return R.ok(treeService.file(file));
    }

    @PostMapping("/unit")
    public R<List<UnitVo>> unit(@RequestParam("id") String id) {
        List<UnitVo> treeVos= treeService.unitListById(id);
        return R.ok(treeVos);
    }



}
