package HomeWork.mapper;

import HomeWork.domain.FloorEntity;
import HomeWork.domain.TreeEntity;
import HomeWork.domain.UnitEntity;
import HomeWork.domain.dto.PlotDto;
import HomeWork.domain.vo.PlotVo;
import HomeWork.domain.vo.TreeVo;
import HomeWork.domain.vo.UnitVo;
import com.baomidou.dynamic.datasource.annotation.DS;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
@DS("slave")
public interface TreeMapper {
    List<TreeEntity> treeList();

    List<TreeEntity> treeListByTreeParentId(Integer parentId);

    List<TreeEntity> findChildren(Integer id);

    List<TreeEntity> treeListByTreeIds(@Param("ids") String[] split);

    List<PlotVo> plotList(Integer id);

    int add(PlotDto plotDto);

    List<TreeEntity> treeListByParentId(Integer parentId);

    List<TreeEntity> treeListByTreeParentIds(@Param("split") String[] split);

    List<TreeEntity> treeByParentId(Integer parentId);

    List<UnitEntity> UnitListById(String id);

    List<FloorEntity> floorById(Integer id);
}
