package HomeWork.service.impl;

import HomeWork.common.core.domain.R;
import HomeWork.domain.*;
import HomeWork.mapper.PeopleMapper;
import HomeWork.service.PeopleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class PeopleServiceImpl implements PeopleService {
    @Autowired
    private PeopleMapper peopleMapper;

    @Override
    public List<People> list() {
        return peopleMapper.list();
    }

    @Override
    public void add(People people) {
        people.setCreateTime(new Date());
        //TODO 通过请求头部获取当前登录用户
        peopleMapper.add(people);
    }

    @Override
    public R delete(Integer id) {
        if (peopleMapper.findById(id)!=null){
            return R.fail("正有布控任务");
        }
        peopleMapper.delete(id);
        return R.ok();
    }

    @Override
    public void upd(People people) {
        peopleMapper.upd(people);
    }

    @Override
    public PeopleOne one(Integer id) {
        People peopleBy = peopleMapper.findPeopleBy(id);
        PeopleOne peopleOnes = peopleMapper.one(id);
        peopleOnes.setPeople(peopleBy);
        return peopleOnes;
    }

    @Override
    public List<ImgsEntity> imgList(Integer id) {
        return peopleMapper.imgList(id);
    }

    @Override
    public Personage PersonageById(Integer id) {
        return peopleMapper.findPersonageById(id);
    }

    @Override
    public void updPersonage(Personage personage) {
        peopleMapper.updPersonage(personage);
    }

    @Override
    public List<Nation> nationList() {
        return peopleMapper.nationList();
    }

    @Override
    public List<IdentityDocument> IdentityDocumentList() {
        return peopleMapper.IdentityDocumentList();
    }
}
