package com.bawei.es.domain;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.Map;

@Data
@Api(tags = "文档索引")
public class DocumentReq {
    @ApiModelProperty(value = "索引名称",required = true)
    @NotNull(message = "索引名称不能为空")
    private String indexName;

    @ApiModelProperty(value = "是否制定文档ID")
    private boolean isNeedId = false;

    @ApiModelProperty(value = "文档ID对应字段")
    private String idField;

    @ApiModelProperty(value = "文档内容")
    private List<Map<String,Object>> documentContent;
}
