package com.bawei.es.remote.api;

import HomeWork.common.core.constant.ServiceNameConstants;
import HomeWork.common.core.domain.R;
import com.bawei.es.domain.*;
import com.bawei.es.remote.factory.RemoteEsDocumentFallbackFactory;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;

/**
 * 用户服务
 *
 * @author bawei
 *
 */
@FeignClient(contextId = "RemoteEsDocService", value = ServiceNameConstants.ES_SERVICE, fallbackFactory = RemoteEsDocumentFallbackFactory.class)
public interface RemoteEsDocService
{
    @ApiOperation("文档插入")
    @PostMapping("/es/document/add")
    public R add(@RequestBody DocumentReq documentReq);

    @ApiOperation("文档删除")
    @PostMapping("/es/document/del")
    public R del(@RequestBody DocumentDelReq documentDelReq);

    @ApiOperation("文档查询")
    @PostMapping("/list")
    public R list(@RequestBody DocumentListReq documentListReq);
}
