package com.bawei.es.remote.factory;


import HomeWork.common.core.domain.R;
import com.bawei.es.domain.DocumentDelReq;
import com.bawei.es.domain.DocumentListReq;
import com.bawei.es.domain.DocumentReq;
import com.bawei.es.remote.api.RemoteEsDocService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * 日志服务降级处理
 *
 * @author bawei
 */
@Component
public class RemoteEsDocumentFallbackFactory implements FallbackFactory<RemoteEsDocService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteEsDocumentFallbackFactory.class);

    @Override
    public RemoteEsDocService create(Throwable cause) {
        log.error("日志服务调用失败:{}", cause.getMessage());
        return new  RemoteEsDocService(){
            @Override
            public R add(DocumentReq documentReq) {
                return R.fail("调用es服务插入数据失败，请稍后重试");
            }

            @Override
            public R del(DocumentDelReq documentDelReq) {
                return R.fail("调用es服务删除数据失败，请稍后重试");
            }

            @Override
            public R list(DocumentListReq documentListReq) {
                return R.fail("调用es服务查询数据失败，请稍后重试");
            }
        };
    }
}
