package com.bawei.es.controller;

import HomeWork.common.core.domain.R;
import com.bawei.es.domain.DocumentDelReq;
import com.bawei.es.domain.DocumentListReq;
import com.bawei.es.domain.DocumentReq;
import com.bawei.es.domain.DocumentUpdReq;
import com.bawei.es.server.EsDocumentServer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api("es文档管理")
@AllArgsConstructor
@RestController
@RequestMapping("/es/document")
public class EsDocumentController {

    private EsDocumentServer esDocumentServer;

    /**
     * 文档插入
     * @param documentReq
     * @return
     */
    @ApiOperation("文档插入")
    @PostMapping("/add")
    public R add(@RequestBody DocumentReq documentReq){
        esDocumentServer.add(documentReq);
        return R.ok();
    }

    /**
     * 文档删除
     * @param documentDelReq
     * @return
     */
    @ApiOperation("文档删除")
    @PostMapping("/del")
    public R del(@RequestBody DocumentDelReq documentDelReq){
        esDocumentServer.del(documentDelReq);
        return R.ok();
    }

    @ApiOperation("文档修改")
    @PostMapping("/upd")
    public R upd(@RequestBody DocumentUpdReq documentReq){
        esDocumentServer.upd(documentReq);
        return R.ok();
    }

    @ApiOperation("文档查询")
    @PostMapping("/list")
    public R list(@RequestBody DocumentListReq documentListReq){
        return R.ok(esDocumentServer.list(documentListReq));
    }


}
