package com.bawei.es.controller;

import HomeWork.common.core.domain.R;
import com.bawei.es.domain.IndexEntry;
import com.bawei.es.domain.IndexInfoReq;
import com.bawei.es.domain.IndexInfoResp;
import com.bawei.es.server.EsIndexService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/es/index")
@Api(tags = "es索引管理")
public class EsIndexController {
    @Autowired
    private EsIndexService esIndexService;
    @RequestMapping("/create")
    @ApiOperation("创建索引")
    public R createIndex(@RequestBody IndexInfoReq indexInfoReq) {
        esIndexService.createIndex(indexInfoReq);
         return R.ok();
    }

    @PostMapping("/del/{indexName}")
    @ApiOperation("删除索引")
    public R delIndex(@PathVariable String indexName){
        esIndexService.delIndex(indexName);
        return R.ok();
    }

    @PostMapping("/get/{indexName}")
    @ApiOperation("判断索引是否存在")
    public R isExistIndex(@PathVariable String indexName){
        boolean isExist = esIndexService.isExistIndex(indexName);
        return R.ok(isExist);
    }

    @PostMapping("/find/{indexName}")
    @ApiOperation("查找索引信息")
    public R<IndexInfoResp> find(@PathVariable String indexName){
        IndexInfoResp indexInfoResp=esIndexService.find(indexName);
        return R.ok(indexInfoResp);
    }

    @PostMapping("/upd")
    @ApiOperation("修改")
    public R updIndex(@RequestBody IndexEntry indexEntry){
        esIndexService.updIndex(indexEntry);
        return R.ok();
    }


}
