package HomeWork.consumer;

import com.bawei.es.domain.DocumentReq;
import com.bawei.es.remote.api.RemoteEsDocService;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.support.Acknowledgment;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Component
public class Consumer {

    @Resource
    private RemoteEsDocService remoteEsDocService;
    /**
     * 开启批量消费
     * @param records
     * @param ack
     */
    @KafkaListener(topics = {"test"},groupId = "2004")
    public void func(List<ConsumerRecord<String, Object>> records, Acknowledgment ack){
        for (ConsumerRecord<String, Object> record : records) {
            String topic = record.topic();
            log.info("订阅topic：{}, 数据内容：{}", topic, record.value());
            DocumentReq documentReq = new DocumentReq();
            documentReq.setIndexName("img");
            ArrayList<Map<String, Object>> maps = new ArrayList<>();
            HashMap<String, Object> stringObjectHashMap = new HashMap<>();
            stringObjectHashMap.put("img",record.value());
            maps.add(stringObjectHashMap);
            documentReq.setDocumentContent(maps);
            remoteEsDocService.add(documentReq);
            // 确认消息已消费
            ack.acknowledge();
        }
    }
}
