package HomeWork.system.utils;

import HomeWork.system.api.domain.SysUser;
import HomeWork.system.mapper.SysUserMapper;
import com.baidu.aip.face.AipFace;
import com.baidu.aip.face.MatchRequest;
import org.apache.commons.compress.utils.IOUtils;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

@Component
public class FaceDetect {
    @Autowired
    private SysUserMapper sysUserMapper;
    public SysUser faceDetect(String face) throws Exception {
        /**
         * 传入appId、apiKey、secretkey。创建Java代码和百度云交互的Client对象
         */
        AipFace client = new AipFace("47745660", "ZEaoK2kFZsLdYQkt8sGrUq6M", "DcFgxv6hTgvPoENNpwKfo9CCGeXqFOAU");

        // 登录图片
        String loginImagePath = face;
        List<SysUser> users=sysUserMapper.selectUserListUserFace();
        if(users.size()>0){
            //循环整个用户信息拿到用户保存的图片
            for (SysUser user : users) {
                // 对比的图片
                String comparedImagePath = user.getFaceImg();

                Double faceComparison = faceComparison(client, loginImagePath, comparedImagePath);
                System.out.println("返回信息："+faceComparison);
                if (faceComparison > 90) {
                    return user;
                }else {
                    //抛异常
                    throw new Exception();
                }
            }
        }
        return null;
    }

    static Double faceComparison(AipFace client, String loginImagePath, String comparedImagePath) throws Exception {
        URL url = new URL(loginImagePath);
        URLConnection conn = url.openConnection();
        byte[] loginImageBytes = IOUtils.toByteArray(conn.getInputStream());
        URL url2 = new URL(comparedImagePath);
        URLConnection conn2 = url2.openConnection();
        byte[] comparedImageBytes = IOUtils.toByteArray(conn2.getInputStream());
        String image1 = Base64Util.encode(loginImageBytes);
        String image2 = Base64Util.encode(comparedImageBytes);

        // image1/image2也可以为url或facetoken, 相应的imageType参数需要与之对应。
        MatchRequest req1 = new MatchRequest(image1, "BASE64");
        MatchRequest req2 = new MatchRequest(image2, "BASE64");
        ArrayList<MatchRequest> requests = new ArrayList<>();
        requests.add(req1);
        requests.add(req2);

        JSONObject match = client.match(requests);
        System.out.println(match.toString(2));
        return match.getJSONObject("result").getDouble("score");
    }

}
